<?php
// Copyright 2000, 2001 Sun Microsystems, Inc.  All rights reserved.
// $Id: license.php,v 1.11 2001/12/08 00:03:09 pbaltz Exp $

include("ServerScriptHelper.php");
include("base/swupdate/updateLib.php");
include_once('Error.php');

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();
$action = "/base/swupdate/downloadHandler.php";

// if cce is suspended, don't bother going any further
if ($cceClient->suspended() !== false)
{
	$msg = $cceClient->suspended() ? $cceClient->suspended() : '[[base-cce.suspended]]';
	print $serverScriptHelper->toHandlerHtml($backUrl, array(new Error($msg)));
	$serverScriptHelper->destructor();
	exit;
}

$factory = $serverScriptHelper->getHtmlComponentFactory("base-swupdate", 
							$action);
$i18n = $factory->getI18n();

// get objects
$package = $cceClient->get($packageOID);
$license = $package["licenseDesc"];
$splash = strstr($package["splashPages"], 'pre-install');

// redirect if we don't have license info. 
$location = "/base/swupdate/downloadHandler.php?packageOID=$packageOID&backUrl=$backUrl";
if (!($license || $splash)) {
	header("location: $location\n\n");
	exit;
}

// we got a splash page. 
if ($splash) {
	$splashdir = updates_splashdir();
	$stage = 'pre-install';
	$name = updates_splashname($package["vendor"], $package["name"],
				   $package["version"], $stage);
	if (file_exists("$splashdir/$name") && $dhandle = opendir("$splashdir/$name")) {
		while ($file = readdir($dhandle)) {
	    	if (strstr($file, 'index.')) {
				$submit = urlencode($location);
				header("location: /$name/?submitURL=$submit&cancelURL=$backUrl\n\n");
				// echo " <ul><li>$name <li>$submit <li> $backUrl </ul>\n";
				exit;
	  		}
		}
		closedir($dhandle);
	}

	if (!$license) {
		header("location: $location\n\n");
		exit;
	}
}

$page = $factory->getPage();

// otherwise, we generate a standard license page

$block0 = $factory->getPagedBlock("licenseField");
$block = $factory->getPagedBlock('');
$block->addFormField($factory->getTextField("nameField", $nameField, ""));
$block->addFormField($factory->getTextField("backUrl", $backUrl, ""));
$block->addFormField($factory->getTextField("packageOID", $packageOID, ""));
$block->addButton($factory->getButton($page->getSubmitAction(), "accept"));
$block->addButton($factory->getButton($backUrl, "decline"));

$stage = 'pre-install';
updates_prependsrc($license, $package['vendor'], $package['name'], 
	$package['version'], $stage);

$serverScriptHelper->destructor();
?>
<?php print($page->toHeaderHtml()); ?>
<SCRIPT LANGUAGE="javascript">
top.code.info_show('');
</SCRIPT>
<?php print($block0->toHtml()); ?>
<TABLE WIDTH="550" CELLPADDING=0 CELLSPACING=4 BORDER=0>
<TR VALIGN="TOP" ALIGN=LEFT><TD>
<?php print($i18n->interpolate($license)); ?>
</TD></TR>
</TABLE>
<?php print($block->toHtml()); ?>
<?php print($page->toFooterHtml()); ?>
