<?php
// Copyright 2000, 2001 Sun Microsystems, Inc.  All rights reserved.
// $Id: manualHandler.php,v 1.30 2001/12/08 00:03:09 pbaltz Exp $

include("ServerScriptHelper.php");
include("Error.php");

// declare some constants
$prepare_cmd = "/usr/sausalito/sbin/pkg_prepare.pl";
$packageDir = "/home/packages";
$pageUrl = "/base/swupdate/manual.php?backUrl=$backUrl";

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();

// check if cce is suspended before proceeding
if ($cceClient->suspended() !== false)
{
	$msg = $cceClient->suspended() ? $cceClient->suspended() : '[[base-cce.suspended]]';
	print $serverScriptHelper->toHandlerHtml($backUrl, array(new Error($msg)));
	$serverScriptHelper->destructor();
	exit;
}

// get any options
$opts = strstr($prepareOpts, 'install') ? '-i' : '';

// find name of the package
$nameField = "";

// reset
$cceClient->setObject("System", array("uiCMD" => "", "message" => "[[base-swupdate.initializing]]", "progress" => 0), "SWUpdate");

// install
if($locationField == "url") {

  // check if URL is secure
  if(substr($urlField, 0, 8) != "https://" && substr($urlField, 0, 7) != "http://" && substr($urlField, 0, 6) != "ftp://") 
  {
    print($serverScriptHelper->toHandlerHtml($pageUrl, 
      	array(new Error("[[base-swupdate.invalidUrl]]"))));

    $serverScriptHelper->destructor();
    exit();
  }

  // package name is the last piece of the URL
  $names = explode("/", $urlField);
  $nameField = $names[count($names)-1];

  // install
  $serverScriptHelper->fork("$prepare_cmd $opts -u \"$urlField\"", 'root');

} else if($locationField == "upload") {

  // package name is the last piece of the supplied file name
  // if windows
  if(!strpos($fileField_name, "\\") === false)
    $names = explode("\\", $fileField_name);
  else
    $names = explode("/", $fileField_name);
  $nameField = $names[count($names)-1];

  $file = '/home/tmp/pkgdownload.';
  $id = posix_getpid(); 
  while (file_exists($file . $id) && (unlink($file . $id) == 0))
	$id++;
  $file .= $id;
  
  if(file_exists($fileField)) {
    rename($fileField, $file);

    // install
    $serverScriptHelper->fork("$prepare_cmd $opts -f $file", 'root');

  } else {

    // Bail with an error on the failed file upload
    print($serverScriptHelper->toHandlerHtml($pageUrl, 
      array( new Error("[[base-swupdate.invalidUpload]]") )));
    $serverScriptHelper->destructor();
    exit();
  }

} else if($locationField == "loaded") {

  $nameField = $loadedField;

  $serverScriptHelper->fork("$prepare_cmd $opts -f \"$packageDir/$loadedField\"", 'root');
}

$nameField = trim($nameField);
$backUrl = trim($backUrl);

print($serverScriptHelper->toHandlerHtml("/base/swupdate/status.php?nameField="
	.rawurlencode($nameField)."&backUrl=/base/swupdate/manual.php&backbackUrl=$backUrl"));

$serverScriptHelper->destructor();
?>
