<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: settingsHandler.php,v 1.15 2001/10/04 22:11:50 will Exp $

include("ArrayPacker.php");
include("ServerScriptHelper.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();

$intervalMap = array("never" => "Never", "daily" => "Daily", "weekly" => "Weekly", "monthly" => "Monthly");

$notifyModeMap = array("all" => "AllNew", "updates" => "UpdatesOnly");

$checkSetMap = array("all" => "All", "updates" => "Updates");

$settings = array(
	"updateInterval" => $intervalMap[$scheduleField],
        "httpProxy" => $httpProxyField, 
	"ftpProxy" => $ftpProxyField,
        "requireSignature" => $requireSignatureField
	);

// Use ActiveMonitor's email contact list if possible
$am_obj = $cceClient->getObject('ActiveMonitor', array(), '');
if( ! $am_obj["alertEmailList"] )
	$settings["updateEmailNotification"] = $emailField;

$cceClient->setObject("System", $settings, "SWUpdate");
$errors = $cceClient->errors();

// remove all the existing servers first
$cceClient->destroyObjects("SWUpdateServer");

// add back all the specified ones
$servers = stringToArray($serverField);
for($i = 0; $i < count($servers); $i++) {
  $cceClient->create("SWUpdateServer", array("location" => $servers[$i],
    "notificationMode" => $notifyModeMap[$notificationLightField], "orderPreference" => $i+1));
  $errors = array_merge($errors, $cceClient->errors());
}

print($serverScriptHelper->toHandlerHtml("/base/swupdate/settings.php", $errors));

$serverScriptHelper->destructor();
?>
