<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: status.php,v 1.10 2000/11/13 21:32:02 will Exp $

include("ServerScriptHelper.php");
include("uifc/PagedBlock.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-swupdate");
$i18n = $serverScriptHelper->getI18n("base-swupdate");

$swupdate = $cceClient->getObject("System", array(), "SWUpdate");
$swupdate["progress"] = round( $swupdate["progress"] );
$cmd = &$swupdate["uiCMD"];

// check to see if we need to redirect to the download page
if (eregi("packageOID=([0-9]+)", $cmd, $reg)) {
	$oid = &$reg[1];
header("location: /base/swupdate/download.php?packageOID=$oid&backUrl=$backbackUrl");
	$cceClient->setObject("System", array("uiCMD" => '', 'progress' => '100'), "SWUpdate");
	exit;
} else if (strstr($cmd, 'reboot')) {
	$page = $factory->getPage();
	print($page->toHeaderHtml());
	print $i18n->get("rebooting");
	print($page->toFooterHtml());
	$cceClient->setObject("System", array("uiCMD" => '', 'progress' => '100'), "SWUpdate");
	exit;
} else if (strstr($cmd, 'refresh')) {
	$page = $factory->getPage();
	print($page->toHeaderHtml());
	if (strstr($cmd, 'uninstall'))
		print($i18n->get("uninstallrefresh"));
	else if (strstr($cmd, 'install'))
		print($i18n->get("installrefresh"));
	print($page->toFooterHtml());
print('<SCRIPT LANGUAGE="javascript">setTimeout("top.location.reload();", 7000);</SCRIPT>');	
	$cceClient->setObject("System", array("uiCMD" => '', 'progress' => '100'), "SWUpdate");
	exit;
}


// get message
$message = $i18n->interpolate($swupdate["message"]);

$page = $factory->getPage();

$block = new PagedBlock($page, "installStatus", $factory->getLabel("installStatus", false, array("fileName" => $nameField)));

$block->addFormField(
  $factory->getTextField("statusField", $message, "r"),
  $factory->getLabel("statusField")
);

$block->addFormField(
  $factory->getBar("progressField", $swupdate["progress"]),
  $factory->getLabel("progressField")
);

// we need to propagate back the URL.
$block->addFormField(
	$factory->getTextField("backbackUrl", $backbackUrl, ""),
	""
);

$block->addButton($factory->getBackButton("$backUrl?backUrl=$backbackUrl"));

$serverScriptHelper->destructor();
?>
<?php print($page->toHeaderHtml()); ?>
<?php print($block->toHtml()); ?>

<?php
// reload if not completed
if($swupdate["progress"] < 100)
  print("<SCRIPT LANGUAGE=\"javascript\">setTimeout(\"location.reload()\", 3000);</SCRIPT>");
?>

<?php print($page->toFooterHtml()); ?>
